Bug 1129630 - Review Request: riemann-c-client - The riemann C client
Summary: Review Request: riemann-c-client - The riemann C client
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Peter Borsa
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-08-13 11:54 UTC by Peter Czanik
Modified: 2014-11-06 21:38 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-11-06 21:38:11 UTC
peter: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Peter Czanik 2014-08-13 11:54:04 UTC
Spec URL: http://peter.czanik.hu/fedora/riemann-c-client.spec
SRPM URL: http://peter.czanik.hu/fedora/riemann-c-client-1.2.1-1.fc22.src.rpm
Description: This is a C client library for the Riemann monitoring system, providing a convenient and simple API, high test coverage and a copyleft license, along with API and ABI stability. It is also the dependency of the syslog-ng incubator project, which I plan to submit next.
Fedora Account System Username: czanik

Comment 1 Ralf Corsepius 2014-08-13 16:33:28 UTC
This package needs quite some amount of work:

* Many rpm anachronisms inside of this spec, which are not neccessary with modern rpm (BuildRoot, %defattr etc.)

* The BR: xz is for the xz-compressed tarball?
Rpm knows to handle xz-compressed tarballs for quite some time.

* The package is not split into *-devel and <main> package properly.
Only the *.so belongs into *devel, *.so.* into <main>

* Don't ship *.la.

* Feel strongly encouraged to not ship static libs (%configure --disable-static)
If you insist on doing so, put them into a *-static subpackage.

* The package seems to contain a test suite but doesn't exercise it?
Is there a special reason for not doing so?

* The %attr's are unnecessary and partially wrong (rpm warns about it).

Comment 2 Peter Czanik 2014-08-14 06:23:14 UTC
I prepared this package originally for SUSE, where I had to support everything from ancient SLES to latest openSUSE Factory release. But now I hope I cleaned up that mess properly :) New spec and source rpms are uploaded:

Spec URL: http://peter.czanik.hu/fedora/riemann-c-client.spec
SRPM URL: http://peter.czanik.hu/fedora/riemann-c-client-1.2.1-2.fc22.src.rpm

The test suit does not seem to be ready yet:

DEBUG: ============================================================================
DEBUG: Testsuite summary for riemann-c-client 1.2.1
DEBUG: ============================================================================
DEBUG: # TOTAL: 0
DEBUG: # PASS:  0
DEBUG: # SKIP:  0
DEBUG: # XFAIL: 0
DEBUG: # FAIL:  0
DEBUG: # XPASS: 0
DEBUG: # ERROR: 0
DEBUG: ============================================================================

Comment 3 Christopher Meng 2014-08-14 06:47:29 UTC
Have been tracking this for months.

1. Requires:	%{name} = %{version}
Requires:	protobuf-c-devel

https://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_Base_Package

Thus:

Requires:        %{name}%{?_isa} = %{version}-%{release}
Requires:        protobuf-c-devel%{?_isa}

Just out of curiousity, why not add json-devel here as well?

2. %configure \
	--disable-static

As you only use one option here, no need to use \.

3. %post
/sbin/ldconfig

%postun
/sbin/ldconfig

->

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

4. In Fedora,

%dir %{_includedir}/riemann/
%dir %{_includedir}/riemann/proto/
%{_includedir}/riemann/*.h
%{_includedir}/riemann/proto/*.h

Can be:

%{_includedir}/riemann/

That's when you want to use a simpler way, not when you want to explicitly list files.

5. Changelog invalid:

http://fedoraproject.org/wiki/Packaging:Guidelines#Changelogs

6. %setup -q -n riemann-c-client-%{version}

->

%setup -q

7. Source tag without full link.

8. Drop Group tag.

Comment 4 Ralf Corsepius 2014-08-14 07:23:28 UTC
Some must fix issues:

1. Rpath.
You may want to apply the tricks described in
http://fedoraproject.org/wiki/Packaging:Guidelines#Removing_Rpath

2. %isa
Requires: %{name}%{?_isa} = %{version}-%{release}

3. empty %clean
%clean is empty and thus is superflous

4. ChangeLog

The rest Christopher mentions is mosty personal preference.

Comment 5 Peter Czanik 2014-08-14 08:19:33 UTC
OK, I also added documentation and hopefully addressed all of the above mentioned problems. For now I used chrpath to fix the rpath issue, but also contacted the upstream developer (a colleague at BalaBit) to provide a proper fix for it in the next release of riemann-c-client.

Spec URL: http://peter.czanik.hu/fedora/riemann-c-client.spec
SRPM URL: http://peter.czanik.hu/fedora/riemann-c-client-1.2.1-2.fc22.src.rpm

Comment 6 Peter Czanik 2014-08-15 09:48:41 UTC
The upstream developer checked the problem and recommended to use github generated sources instead of "make dist" generated sources and run "autoreconf -i" as part of the package building process. According to him, Fedora uses a modified libtool, which behaves differently than the one on his system.

Is such a change OK? (previously I was told, that the use of autotools is discouraged) Here is a diff, how the spec file would change from the previously posted version:

[czanik@localhost riemann-c-client]$ diff -u riemann-c-client.spec.old riemann-c-client.spec
--- riemann-c-client.spec.old	2014-08-15 10:11:58.280937822 +0200
+++ riemann-c-client.spec	2014-08-15 11:26:49.345601699 +0200
@@ -6,15 +6,17 @@
 
 Name:		riemann-c-client
 Version:	1.2.1
-Release:	3%{?dist}
+Release:	4%{?dist}
 Summary:	The riemann C client
 License:	GPLv2
 Url:		https://github.com/algernon/riemann-c-client
-Source:		https://github.com/algernon/riemann-c-client/releases/download/riemann-c-client-%{version}/riemann-c-client-%{version}.tar.xz
+Source:		https://github.com/algernon/riemann-c-client/releases/download/riemann-c-client-%{version}/riemann-c-client-%{version}.tar.gz
 BuildRequires:	pkgconfig
 BuildRequires:	protobuf-c-devel
 BuildRequires:	json-c-devel
-BuildRequires:	chrpath
+BuildRequires:	autoconf
+BuildRequires:	automake
+BuildRequires:	libtool
 
 %description
 This is a C client library for the Riemann monitoring system, providing a
@@ -31,9 +33,10 @@
 This package provides files necessary for riemann-c-client development.
 
 %prep
-%setup -q
+%setup -q -n riemann-c-client-riemann-c-client-%{version}
 
 %build
+autoreconf -i
 %configure \
 	--disable-static \
 	--disable-rpath
@@ -43,8 +46,6 @@
 %install
 make DESTDIR=${RPM_BUILD_ROOT} install
 
-chrpath --delete $RPM_BUILD_ROOT%{_bindir}/riemann-client
-
 rm %{buildroot}/%{_libdir}/libriemann-client.la
 
 %post -p /sbin/ldconfig

Comment 7 Christopher Meng 2014-08-15 09:56:45 UTC
Please consider using autoreconf -iv or autoreconf -fiv to get verbose output at lease(-f means force, treating all files obsolete).

Comment 8 Peter Czanik 2014-08-15 10:17:45 UTC
Done. New srpm and spec files are uploaded:

Spec URL: http://peter.czanik.hu/fedora/riemann-c-client.spec
SRPM URL: http://peter.czanik.hu/fedora/riemann-c-client-1.2.1-4.fc22.src.rpm

Comment 9 Ralf Corsepius 2014-08-15 11:19:20 UTC
I would have approved this package without autoreconf. But provided upstream refuses to correctly use the autotools and unable to provide proper tarballs (I.e. to run make dist), I'll step down from this review.

Comment 10 Peter Czanik 2014-08-15 12:40:04 UTC
In the previous, rev. 3 of the package I used the "make dist" tarball together with chrpath. I can revert to that, if that one is better.

Comment 11 Peter Czanik 2014-08-19 06:58:32 UTC
I see now the following options for going forward:

- going with version 3 of the package (using chrpath)

- going with version 4 of the package (using autoreconf)

- remove the affected binary, as it's not for everyday use, just as a reference implementation.

What do you think?

Comment 12 Peter Borsa 2014-10-19 15:49:43 UTC
Peter,

can you give us a version 3 of this package because I'll review it.

Comment 13 Peter Czanik 2014-10-19 16:08:39 UTC
It's available at http://peter.czanik.hu/fedora/riemann-c-client-1.2.1-3.fc22.src.rpm

Comment 14 Peter Czanik 2014-10-19 16:57:31 UTC
The spec file is available at http://peter.czanik.hu/fedora/riemann-c-client.spec

Comment 15 Peter Borsa 2014-10-28 12:40:48 UTC
MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

MUST: The package must be named according to the Package Naming Guidelines .

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.

MUST: The package must meet the Packaging Guidelines .

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

MUST: The License field in the package spec file must match the actual license.

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.

MUST: The spec file must be written in American English.

MUST: The spec file for the package MUST be legible.

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.

MUST: Packages must NOT bundle copies of system libraries.

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.

MUST: Each package must consistently use macros.

MUST: The package must contain code, or permissible content.

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.

MUST: Static libraries must be in a -static package.

MUST: Development files must be in a -devel package.

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.

MUST: All filenames in rpm packages must be valid UTF-8.

===

Approved.

Comment 16 Peter Czanik 2014-11-03 11:45:03 UTC
New Package SCM Request
=======================
Package Name: riemann-c-client
Short Description: The riemann C client
Upstream URL: https://github.com/algernon/riemann-c-client
Owners: czanik
Branches: f21 epel7
InitialCC:

Comment 17 Gwyn Ciesla 2014-11-03 13:42:38 UTC
Git done (by process-git-requests).

Comment 18 Gwyn Ciesla 2014-11-05 12:36:00 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.